/*
 *  ad_recorder.h
 *  AudioDiary
 *
 *  Created by Roy Fejgin on 3/7/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */


#ifndef __AD_RECORDER__
#define __AD_RECORDER__

#include <AudioToolbox/AudioToolbox.h>
#include <Foundation/Foundation.h>
#include <libkern/OSAtomic.h>

#include "CAStreamBasicDescription.h"
#include "CAXException.h"

#include "my_defs.h"
#include "circular_buffer.h"
#import "mo_location.h"
#import "Stk.h"
#import "mo_thread.h"
using namespace stk;


class AdRecorder {
public:
    AdRecorder();
    
    void startRecord();
    void writeBuffer(CircularBuffer<SAMPLE>*, int n, bool sync=false);
    NSString* stopRecord();
    void setupAudioFormat(UInt32 inFormatID);
    
    // Converts a buffer from floats in the range [-1,1] to a 16 bit signed integers
    static void convertToSint16(SINT16* bufOut, SAMPLE* bufIn, int len);
    
    static void* writeBuf(void* data);

private:
    void testFileUpload();

    NSString*					m_fileName;
    AudioFileID					m_fileHandle;
    CAStreamBasicDescription	m_recordFormat;

    // offset into file being written
    int                         m_offset;
    MoThread                    m_thread;
};

typedef struct ThreadData
{
    CircularBuffer<SAMPLE>* buf;
    int n;
    AdRecorder* rec;
    volatile bool locked;
}ThreadData;


#endif //__AD_RECORDER__