/*
 *  AudioClipPlayer.cpp
 *  Sonic
 *
 *  Created by Roy Fejgin on 2/7/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

#include "AudioClipPlayer.h"
#include "FileWvIn.h"

AudioClipPlayer::AudioClipPlayer(const char* path, SAMPLE scale, int numPlayers) 
                                 : m_scale(scale), m_numPlayers(numPlayers)
{
    for(int i=0; i<m_numPlayers; i++) {
        m_players[i] = new FileWvIn();
        m_players[i]->openFile(path);
        m_active[i] = false;
    }
}

void AudioClipPlayer::playClip()
{
    // try to find an available player and start it
    for (int i=0; i<m_numPlayers; i++) {
        if (!m_active[i]) {
            m_active[i] = true;
            break;
        }
    }
}

bool AudioClipPlayer::isDone()
{
    bool done = true;
    // Search for any active players
    for (int i=0; i<m_numPlayers; i++) {
        if (m_active[i]) {
            done = false;
            break;
        }
    }
    
    return done;
}

SAMPLE AudioClipPlayer::tick()
{
    SAMPLE output = 0.0;
    for (int i=0; i<m_numPlayers; i++){
        FileWvIn* pPlayer = m_players[i];
        if (m_active[i] == true) {
            output += pPlayer->tick();
        }
        
        if (m_active[i] && pPlayer->isFinished()) {
            m_active[i] = false;
            pPlayer->reset();
        }
    }
    
    return output*m_scale;
}

//    m_hitWav = new stk::FileWvIn( hitPath );

