/*
 *  AudioManager.h
 *  AudioDiary
 *
 *  Created by Roy Fejgin on 3/8/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */


#ifndef __AUD_MGR__
#define __AUD_MGR__

#import "AdRecorder.h"
#import "TapAnalyzer.h"
#import "AudioClipPlayer.h"
#import "ClipManager.h"

#define NUM_BUFFERS 2

class AudioManager
{
public:
    AudioManager();
    ~AudioManager() {
        delete m_recorder;
        delete m_analyzer;
        delete m_clipPlayer;
    }
    
    SAMPLE tick(SAMPLE input);
    
    void setClipManager(ClipManager* mgr) { m_clipManager = mgr; }
        
private:
    inline void advanceBuffer() {
        m_bufIndex++;
        m_bufIndex = m_bufIndex % NUM_BUFFERS;
    }
    
    AdRecorder* m_recorder;
    TapAnalyzer* m_analyzer;
    AudioClipPlayer* m_clipPlayer;
    ClipManager* m_clipManager;
    
    // Double buffer
    CircularBuffer<SAMPLE>* m_buffers[NUM_BUFFERS];
    // Active buffer (i.e. the one currently being filled).
    int m_bufIndex;
    
    int m_delaySamples;
    long m_samplesSinceSave;
    bool m_isRecording;
    NSTimeInterval m_startTime;
};



#endif //__AUD_MGR__