/*
 *  ChordSelector.cpp
 *  Harmonizer
 *
 *  Created by Roy Fejgin on 2/13/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

#import "ChordSelector.h"
#import "my_util.h"
#import "my_defs.h"∫

bool ChordSelector::touchEvent(const std::map<int, MoTouchTrack> & touchPts, UIView * views, ChordType* outchord)
{
    UIView * vview = (UIView *)views;
    int numTriadTouch = 0;
    int numExtTouch = 0;
    ChordType chord = ChordType();
    bool changed = false;
    QuadrantData quad = {0};
    
    // Examine all live touches
    for(MoTouch::MoTouchMapIt  iter = touchPts.begin(); iter != touchPts.end(); ++iter) {
        UITouch* pTouch = iter->second.touch;
        CGPoint point = converToWorld([pTouch locationInView:vview]);
        switch ([pTouch phase]) {
            case UITouchPhaseBegan:
            case UITouchPhaseMoved:
            case UITouchPhaseStationary:
                if(point.x < 0) {
                    numTriadTouch++;
                    if (point.y > 0) {
                        chord.triad = CH_MIN;
                        quad.quad[1] = true;
                    }
                    else {
                        chord.triad = CH_MAJ;
                        quad.quad[2] = true;
                    }

                }
                else {
                    numExtTouch++;
                    if (point.y > 0) {
                        chord.ext = EXT_SEV_MIN;
                        quad.quad[0] = true;
                    }
                    else {
                        chord.ext = EXT_SEV_MAJ;
                        quad.quad[3] = true;
                    }
                }
                break;
            default:
                break;
        }
    }
    
    if (numTriadTouch == 2) {
        chord.triad = CH_DIM;
    }
    else if (numTriadTouch >= 3) {
        chord.triad = CH_AUG;
    }
    
    if (numExtTouch >= 2) {
        chord.ext = EXT_SEV_DIM;
    }
    
    quad.half[0] = numExtTouch;
    quad.half[1] = numTriadTouch;
    
    
    DEBUG_LOG(@"Triad type: %d", chord.triad);
    DEBUG_LOG(@"Ext type: %d", chord.ext);
    if (!(chord == m_chord)) {
        changed = true;
    }
    // Save new chord and quadrant data
    memcpy(&m_quad, &quad, sizeof(quad));
    m_chord = chord;
    
    if (outchord != NULL) {
        *outchord = chord;
    }

    return changed;
}
