//
//  RecordController.m
//  AudioDiary
//
//  Created by Roy Fejgin on 3/13/10.
//  Copyright __MyCompanyName__ 2010. All rights reserved.
//

#import "RecordController.h"


@implementation RecordController

- (void)awakeFromNib
{
    NSLog(@"RecordController awake from Nib");

    
    NSLog(@"Creating audio manager for record controller");
    m_audioManager = new AudioManager();
    
    [[NSNotificationCenter defaultCenter]
     addObserver:self
     selector:@selector(handleNotification:)
     name:@"RecordStatus"
     object:nil];
}


- (SAMPLE) tick: (SAMPLE) input
{
    return m_audioManager->tick(input);
}


-(void)handleNotification:(NSNotification *)pNotification
{
    bool recordStatus = [(NSNumber*)[pNotification object] boolValue];

    NSLog(@"RecordController received message %d", recordStatus);

    if (recordStatus) {
        
        // TODO - set background color, e.g.
        recordView.backgroundColor = [UIColor colorWithRed:255.0/255.0 green:0./255.0 blue:0./255.0 alpha:1.0]; 
        statusLabel.textColor = [UIColor colorWithRed:.0/255.0 green:0./255.0 blue:255./255.0 alpha:1.0];

        [self updateDisplay: @"RECORDING": statusLabel];
    }
    else {
        recordView.backgroundColor = [UIColor colorWithRed:127./255.0 green:127./255.0 blue:127./255.0 alpha:1.0]; 
        statusLabel.textColor = [UIColor colorWithRed:30./255.0 green:200./255.0 blue:40./255.0 alpha:1.0];

        [self updateDisplay: @"Monitoring": statusLabel];
    }
}

// Update on main thread
-(void) updateDisplay : ( NSString *)str : (UILabel*) label
{
    [label performSelectorOnMainThread : @ selector(setText : ) withObject:str waitUntilDone:YES];
}


-(void) setClipManager : ( ClipManager * )mgr
{
    m_audioManager->setClipManager(mgr);
}

/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/

/*
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
}
*/

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/



- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}

@end
