//
//  SelectController.m
//  AudioDiary
//
//  Created by Roy Fejgin on 3/19/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "SelectController.h"
#import "ASIHTTPRequest.h"
#import "ASIFormDataRequest.h"
#import "BrowseController.h"

@implementation SelectController


@synthesize currentProperty;



- (void)awakeFromNib
{
    NSLog(@"SelectController awake from Nib");
}


- (SAMPLE) tick: (SAMPLE) input
{
    return 0.0;
}

/*
 -(IBAction)hitNearby
 {
 NSLog(@"Hit nearby!");
 }
 */
-(IBAction)hitRecent
{
    NSLog(@"Hit recent!");
}


/*
 // The designated initializer. Override to perform setup that is required before the view is loaded.
 - (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
 if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
 // Custom initialization
 }
 return self;
 }
 */

/*
 // Implement loadView to create a view hierarchy programmatically, without using a nib.
 - (void)loadView {
 }
 */

/*
 // Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
 - (void)viewDidLoad {
 [super viewDidLoad];
 }
 */

/*
 // Override to allow orientations other than the default portrait orientation.
 - (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
 // Return YES for supported orientations
 return (interfaceOrientation == UIInterfaceOrientationPortrait);
 }
 */



- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}


extern const NSString * server;
- (IBAction) hitNearby {
	
    NSLog(@"Hit nearby! -> getting XML");
    
    NSLog(@"Getting XML data");
	
    NSURL * URL = [[NSURL alloc] initWithString:[server stringByAppendingString:@"getEvents.php"]];
	
	// Form the request
	ASIFormDataRequest *request = [ASIFormDataRequest requestWithURL:URL];
	[request setPostValue:@"2" forKey:@"num_requests"]; 
	
	// Start sending synchronously
	[request startSynchronous];
	
	// Display any error messages
	NSError *error = [request error];
	if (error) {
		NSString *response = [request responseString];
        NSLog(@"Error while trying to pull nearby XML");
		NSLog(response);
	}
	
	// Parse the raw response using XML
    NSXMLParser * xmlParser = [[NSXMLParser alloc] initWithData:[request rawResponseData]];
    [xmlParser setDelegate:self];
    [xmlParser setShouldProcessNamespaces:NO]; // We don't care about namespaces
    [xmlParser setShouldReportNamespacePrefixes:NO]; //
    [xmlParser setShouldResolveExternalEntities:NO]; // We just want data, no other stuff
    
    [xmlParser parse];  // start parsing (event driven)
	
    [xmlParser release];
    [URL release];
}

//////////////////////////////////// Start NSXMLParserDelegate Protocol Methods ///////////////////////////////////////////////
- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string
{
    // our example is not using this, but it can be useful
    if (self.currentProperty) {
        [currentProperty appendString:string];
    }
}


- (void)parserDidStartDocument:(NSXMLParser *)parser {
    NSLog(@"Start XML parsing");

    // TODO memory leak!! (string)
    m_events->clear();
    //[text setText:@""];
}

- (void)parserDidEndDocument:(NSXMLParser *)parser {
    NSLog(@"End XML parsing");
    [self loadTable];
    
    // in case you want to do something when the XML document parsing ends
}

- (void)parser:(NSXMLParser *)parser 
didStartElement:(NSString *)elementName 
  namespaceURI:(NSString *)namespaceURI 
 qualifiedName:(NSString *)qName 
    attributes:(NSDictionary *)attributeDict {
    
    // not sure what this do (probably escape characters)
    if (qName) {
        elementName = qName;
    }

    if ([elementName isEqualToString:@"event"]) {
        
        Event event;
        event.id = [[NSString stringWithString: [attributeDict objectForKey:@"id"]] retain];
        event.latitude = [[NSString stringWithString:[attributeDict objectForKey:@"latitude"]]retain];
        event.longitude = [[NSString stringWithString:[attributeDict objectForKey:@"longitude"]]retain];
        event.text_val = [[NSString stringWithString:[attributeDict objectForKey:@"text_val"]]retain];
        event.num_val = [[NSString stringWithString:[attributeDict objectForKey:@"num_val"]]retain];
        
        m_events->push_back(event);
        
        // append this event to other events on the screen
        //[text setText:[NSString stringWithFormat:@"%@id:\t%@\nlatitude:\t%@\nlongitude:\t%@\ntext_val:\t%@\nnum_val:\t%@\n", [text text], event.id, event.latitude, event.longitude, event.text_val, event.num_val]];
    }
    
    
}

- (void) setEvents:(vector<Event> *)events
{
    m_events = events;
}



- (void)parser:(NSXMLParser *)parser 
 didEndElement:(NSString *)elementName 
  namespaceURI:(NSString *)namespaceURI 
 qualifiedName:(NSString *)qName {
    
    // Do something here
    if (qName) {
        elementName = qName;
    }
}


- (void)loadTable
{
    // Tell the browse controller to load itself
    [[NSNotificationCenter defaultCenter] 
     postNotificationName:@"DoBrowse"
     object:nil];
    
}
//////////////////////////////////// End NSXMLParserDelegate Protocol Methods ///////////////////////////////////////////////

@end
