//
//  UploadController.h
//  AudioDiary
//
//  Created by Roy Fejgin on 3/13/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#ifndef __UPLOAD_CONT__
#define __UPLOAD_CONT__

#import <UIKit/UIKit.h>
#import "my_defs.h"
#import "ClipManager.h"
#import "ASIHTTPRequest.h"

@interface UploadController : UITableViewController {
    IBOutlet UITableView* uploadView;
    ClipManager* m_clipManager;
    int m_numClips;
    NSArray *timeZoneNames;
    NSOperationQueue* queue;
    
    // this should be a queue...
    int m_currentClip;
    NSString* m_currentClipLabel;
    BOOL m_uploading;
    NSIndexPath* m_indexPath;
    
}
@property (nonatomic, retain) NSArray *timeZoneNames;
@property (nonatomic, retain)NSOperationQueue * queue;


@property (nonatomic, retain) NSString* m_currentClipLabel;
@property (nonatomic, retain) NSIndexPath* m_indexPath;



-(void)handleNotification:(NSNotification *)pNotification;
- (BOOL)uploadFile:(NSString*) fileName: (Clip*) clip;
-(void) updateDisplay : ( NSString *)str : (UILabel*) label;
-(void) reloadTable;

-(void)requestDone:(ASIHTTPRequest *)request;
-(void)requestWentWrong:(ASIHTTPRequest *)request;



- (SAMPLE) tick: (SAMPLE) input;
-(void) setClipManager : ( ClipManager * )mgr;

@end


#endif // __UPLOAD_CONT__