/*
 *  Clip.h
 *  AudioDiary
 *
 *  Created by Roy Fejgin on 3/15/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef __CLIP__H_
#define __CLIP__H_

#import "mo_audio.h"
#import "mo_location.h"
#import "my_defs.h"
#import "my_util.h"


class Clip 
{
public:
    // constructor
    Clip(CLLocationCoordinate2D location,
         NSTimeInterval startTime,
         float length,
         NSString* fileName,
         NSString* userName = NULL,
         NSString* tag = NULL) :
            m_coord(location),
            m_startTime(startTime),
            m_length(length),
            m_fileName(fileName),
            m_userString(userName),
            m_tagString(tag) { 
    }
    
    // accessors
    CLLocationCoordinate2D getCoord() { return m_coord; }
    NSTimeInterval getStartTime() { return m_startTime; }
    float getLength() { return m_length; }
    NSString* getFilename() { return m_fileName; }
    NSString* getUser() { return m_userString; }
    NSString* getTags() { return m_tagString; }
    
private:
    CLLocationCoordinate2D m_coord;
    NSTimeInterval m_startTime;
    float m_length;
    NSString* m_fileName;
    NSString* m_userString;
    NSString* m_tagString;
    
};

#endif //__CLIP__H_