/*
 *  ClipManager.cpp
 *  AudioDiary
 *
 *  Created by Roy Fejgin on 3/15/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

#include "ClipManager.h"


ClipManager::ClipManager() 
{
    m_player = NULL;
}

void ClipManager::addClip(CLLocation* location,
                         NSTimeInterval startTime,
                         float length,
                         NSString* fileName,
                         NSString* userName,
                         NSString* tag)
{
    // Create clip
    Clip clip([location coordinate],
              startTime,
              length,
              fileName,
              userName,
              tag);
    
    addClip(&clip);
    
    // TODO sort
}

void ClipManager::addClip(Clip* clip)
{
    // Retain 
    [clip->getFilename() retain];
    
    if (clip->getUser() != NULL) {
        [clip->getUser() retain];
    }

    if (clip->getTags() != NULL) {
        [clip->getTags() retain];
    }
    
    // Save clip
    m_clips.push_back(*clip);
}

void ClipManager::startIteration()
{
    // Initialize iterator
    //m_clipIter = m_clips.begin();
}

Clip* ClipManager::nextClip()
{
    
    Clip* clip = NULL;
    /*
    if (m_clipIter != m_clips.end()) {
        clip = &(*m_clipIter);
        m_clipIter++;
    }
    */
    return clip;
}

void ClipManager::playClip(Clip* clip)
{
    if (m_player != NULL) {
        // TODO lock?
        delete m_player;
    }
   
    m_player = new AudioClipPlayer([clip->getFilename() UTF8String ], 1.0, 1);
}


SAMPLE ClipManager::tick()
{
    SAMPLE output = 0.0;
    
    if (m_player != NULL) {
        output += m_player->tick();
    }
    
    return output;
}


// DEBUG

void ClipManager::listDirectory()
{
    NSArray *dirContents = [[NSFileManager defaultManager] directoryContentsAtPath:NSTemporaryDirectory()];
	NSLog(@"Number of files = %d", dirContents.count);
	
	for (int i=0; i < dirContents.count; i++) {
        NSLog (@"%d: <%@>", i, [dirContents objectAtIndex:i]);
    }
}
