//
//  ES1Renderer.h
//  SonicSlingShot
//
//  Created by Roy Fejgin on 1/29/10.
//  Copyright __MyCompanyName__ 2010. All rights reserved.
//

#import "ESRenderer.h"
#import <OpenGLES/ES1/gl.h>
#import <OpenGLES/ES1/glext.h>
#import <map>
#import "mo_touch.h"
#import "HarmonyModel.h"
#import "ui_chord.h"

@interface ES1Renderer : NSObject <ESRenderer>
{
@private
	EAGLContext *context;
	
	// The pixel dimensions of the CAEAGLLayer
	GLint backingWidth;
	GLint backingHeight;
	
	// The OpenGL names for the framebuffer and renderbuffer used to render to this view
	GLuint defaultFramebuffer, colorRenderbuffer;
    
    HarmonyModel* pModel;
    UI_Chord* pUIChord;
}
- (void)fluteOff;
- (void)fluteOn;
- (void) render;
- (void) loadTextTexture:(NSString*) pStr:(GLuint*) name;
- (void) loadTextTexture:(NSString*) pStr:(GLuint*) name:(BOOL)small;
- (void) loadTextures;
- (BOOL) resizeFromLayer:(CAEAGLLayer *)layer;
- (void) touchEvent:(const std::map<int, MoTouchTrack>*) touchPts: (UIView*) view;
- (GLfloat) renderAudio: (SAMPLE) input;

//void touchEvent(const std::map<int, MoTouchTrack> & touchPts, UIView * view);


@end
