/*
 *  HarmonyAudio.cpp
 *  
 *
 *  Created by Roy Fejgin on 2/14/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

#import "HarmonyAudio.h"


HarmonyAudio::HarmonyAudio() : m_isPitShiftMode(true)
{
    for (int i=0; i<MAX_VOICES; i++) {
//        m_voices[i] = new VoicForm();
        m_voices[i] = new Flute(80);

        m_shifters[i] = new PitShift();
        m_active[i] = false;
    }
}


SAMPLE HarmonyAudio::tick(SAMPLE inSamp)
{
    SAMPLE output = 0.0;

    if (m_isPitShiftMode) {
        for (int i=0; i<MAX_VOICES; i++) {
            if (m_active[i]) {
                output += m_shifters[i]->tick(inSamp);
            }
        }
    }
    else {
        for (int i=0; i<MAX_VOICES; i++) {
            if (m_active[i]) {
                output += m_voices[i]->tick();
            }
        }
    }
    return output;
}

void HarmonyAudio::clear()
{
    for (int i=0; i<MAX_VOICES; i++) {
        if (m_active[i]) {
            m_shifters[i]->clear();
        }
        // TODO clear voiceforms?
    }
}

void HarmonyAudio::setHarmony(float fundFreq, vector<float>& ratios, bool copyrRatios)
{
    const float gain = 0.1;
    
    int i = 0;
    
    for(vector<float>::iterator  iter = ratios.begin(); iter != ratios.end(); ++iter, ++i) {
        assert(i<MAX_VOICES);
        float ratio = *iter;
        
        if (m_isPitShiftMode) {
            m_shifters[i]->setShift(ratio);
        } 
        else {
            m_voices[i]->noteOn(fundFreq*ratio, gain);
        }
        m_active[i] = true;
    }
    
    // Disable voices that have stopped
    for(; i<MAX_VOICES; i++) {
        m_active[i] = false;
    }
    
    if (copyrRatios) {
        m_ratios =  ratios;
    }
}
/*
class HarmonyAudio
{
public:
    HarmonyAudio();
    
    SAMPLE tick( SAMPLE input);
    
    void setHarmony(float fundFreq, list<float>& ratios);
private:
    m_pitShift*;
    m_voice*;
}
*/