/*
 *  PitchDetector.h
 *  Uses autocorrelation to detect pitch.
 *  The autocorrelation is computed using FFT.
 *
 *  Created by Roy Fejgin on 2/15/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef _PITCH_DETECTOR__
#define _PITCH_DETECTOR__


#import "mo_fft.h"
#import "my_defs.h"

class PitchDetector
{
public:
    PitchDetector(int frameSize, float sampleRate);
    bool tick(SAMPLE input);
    
    inline float getPitch() { return m_pitch; }
    
private:
    static const float zeroPadFactor = 2;
    void computeAutoCorrelation(complex* inFftBuffer, complex* outBuffer, int length);
    SAMPLE* m_buffer;
    SAMPLE* m_window;
    SAMPLE* m_autoCorrBuffer;
    int m_index;
    int m_frameSize;
public:
    float m_sampleRate;
    float m_pitch;
};



#endif //_PITCH_DETECTOR__