/*
 *  TapAnalyzer.h
 *  AudioDiary
 *
 *  Created by Roy Fejgin on 3/8/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */


#ifndef __TAP_ANALYZER__
#define __TAP_ANALYZER__

#include "circular_buffer.h"
#include "my_defs.h"
#include "OnePole.h"

using namespace stk;

typedef enum TapType {
    TAP_NONE=0,
    TAP_START,
    TAP_STOP,
    TAP_START_DISCARD,
    TAP_ERASE,
    TAP_LAST
} TapType;

class TapAnalyzer {
public:
    TapAnalyzer(CircularBuffer<SAMPLE>& buffer, int maxLookback);
    ~TapAnalyzer() { delete m_onePole; }
    
    TapType tick(SAMPLE input);
    
    void setLookback(int maxLookback) {
        m_maxLookback = maxLookback; 
        // TODO - clear analysis state
    }
private:
    CircularBuffer<SAMPLE>& m_buffer;
    
    // Enevlope follower
    OnePole* m_onePole;
    int m_backoff;
    
    int m_maxLookback;
    
};

#endif //__TAP_ANALYZER__