#ifndef __MY_DEFS__
#define __MY_DEFS__


#import <stdio.h>
#import <OpenGLES/ES1/gl.h>
#import "mo_def.h"

// This files contains some basic definitions to be used
// throughout the project

#define MY_PI	ONE_PI


// Define some common types
typedef double MyFloat64;
typedef unsigned int MyUint32;
typedef unsigned char MyUint8;


// Hack...
#ifndef SAMPLE
#define SAMPLE Float32
#endif

//#define DEBUG_ON

#ifdef DEBUG_ON
#define DEBUG_LOG(x, ...)    NSLog(x, ## __VA_ARGS__)	
#define DEBUG_PRINTF(x, ...)        do { printf(x, ## __VA_ARGS__); fflush(stdout); } while(0);
#else  
#define DEBUG_PRINTF
#define DEBUG_LOG
#endif


/********************************************************************************* 
 Mutex
 **********************************************************************************/

#include <unistd.h>  
#include <pthread.h>
// Mutex related definitions
typedef pthread_mutex_t OsMutex;
#define MUTEX_INITIALIZE(A) pthread_mutex_init(A, NULL)
#define MUTEX_DESTROY(A)    pthread_mutex_destroy(A)
#define MUTEX_LOCK(A)       pthread_mutex_lock(A)
#define MUTEX_UNLOCK(A)     pthread_mutex_unlock(A)

#define OS_SLEEP( X ) usleep(X)



#endif //__MY_DEFS__

