/*
 *  ui_chord.h
 *  Contains the entire GUI for this instrument:
 *  - draws the labels, buttons, and "active chord" display.
 *
 *  Created by Roy Fejgin on 2/14/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */


#ifndef __UI_CHORD__
#define __UI_CHORD__


#include "ui_element.h"
#include "HarmonyModel.h"

class  UI_Chord : public UI_Element
{
public:
    UI_Chord(HarmonyModel* pModel) : m_model(pModel) {}
    
    virtual void draw();
    
private:
    void drawSeparators(QuadrantData& quad);
    void drawQuads(const QuadrantData& quad);
    void drawActiveChord(ChordType chord);
    void drawLabels(QuadrantData& quad, ChordType chord);
    
    HarmonyModel* m_model;
    GLuint m_texture;
    
};










#endif //__UI_CHORD__